program checkoutput
!use realsame_mod
use dal
use errorhandling

implicit none

type(DataSetT)  :: hkfile
type(TableT)    :: hktab
type(ColumnT)   :: time, ahfra, dahfom
real(double), dimension(:), pointer :: p_time, p_ahfra, p_dahfom
logical ok

ok = .true. 
!-------------------------------------------------------------------------
write (*,*) 'testing atthk.dat file'
hkfile = dataSet("atthk.dat", read)
hktab = table(hkfile,"ATTHK")

if (.not.hasColumn(hktab,"TIME") .or. &
    .not.hasColumn(hktab,"AHFRA")) ok = .false.
if (.not.ok) call error("noColumn","TIME and/or AHFRA Column absent or incorrectly named")
ok = .true.

time = column(hktab,"TIME",read)
ahfra = column(hktab,"AHFRA",read)
dahfom = column(hktab,"DAHFOM",read)
p_time => real64Data(time)
p_ahfra => real64Data(ahfra)
p_dahfom => real64Data(dahfom)

write (*,*) p_time(0)
if (p_time(0) < (5.0223248E+7 + 63.184).or. p_time(0) > (5.0223251E+07 + 63.184)) ok = .false.
if (.not.ok) call error("wrongTime","TIME values incorrect")
ok = .true.

if (p_ahfra(0) < 11.99 .or. p_ahfra(0) > 12.02) ok = .false.
if (.not.ok) call error("wrongAhfra","AHFRA values incorrect")
ok = .true.

if (p_dahfom(0) < -0.001 .or. p_dahfom(0) > 0.001) ok = .false.
if (.not.ok) call error("wrongAhfra","DAHFOM values incorrect")
ok = .true.

call release(hktab)
call release(hkfile)

!--------------------------------------------------------------------------
!-------------------------------------------------------------------------
write (*,*) 'testing atthkbad.dat file'
hkfile = dataSet("atthkbad.dat", read)
hktab = table(hkfile,"ATTHK")

if (.not.hasColumn(hktab,"TIME") .or. &
    .not.hasColumn(hktab,"AHFRA")) ok = .false.
if (.not.ok) call error("noColumn","TIME and/or AHFRA Column absent or incorrectly named")
ok = .true.

time = column(hktab,"TIME",read)
ahfra = column(hktab,"AHFRA",read)
dahfom = column(hktab,"DAHFOM",read)
p_time => real64Data(time)
p_ahfra => real64Data(ahfra)
p_dahfom => real64Data(dahfom)

write (*,*) p_time(0)
if (p_time(0) < (5.2569732E+7 + 63.184) .or. p_time(0) > (5.2569734E+07 + 63.184)) ok = .false.
if (.not.ok) call error("wrongTime","TIME (bad) values incorrect")
ok = .true.

if (.not.isNull(ahfra,0)) ok = .false.
if (.not.ok) call error("notNullAhfra","AHFRA values are not NULL")
ok = .true.

if (isNull(ahfra,0)) write (*,*) "NULL found - good"

call release(hktab)
call release(hkfile)

!--------------------------------------------------------------------------
end


